package com.skywang;

import android.app.Activity;
import android.os.Bundle;
import android.os.IBinder;
import android.os.RemoteException;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.content.ComponentName;
import android.content.Intent;
import android.content.Context;
import android.content.ServiceConnection;
import com.test.MyAIDLInterface;

public class AIDLServiceTest extends Activity {
    private static final String TAG = "skywang-->AIDLServiceTest";

    private Button mStart = null;
    private Button mHalf = null;
    private Button mDouble = null;
    private Button mEnd = null;
    
    private MyAIDLInterface mBinder = null;
    private ServiceConnection mConnection = new ServiceConnection() {
        
        @Override 
        public void onServiceDisconnected(ComponentName name) {
            mBinder = null;    
        }
    
        @Override
        public void onServiceConnected(ComponentName name, IBinder service) {
            Log.d(TAG, "Service connected!");
            mBinder = MyAIDLInterface.Stub.asInterface(service);
        }
    };
    
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.aidlservice_test);        

        mStart = (Button) findViewById(R.id.btStart);
        mStart.setOnClickListener(new View.OnClickListener() {
            
            @Override
            public void onClick(View arg0) {
                Log.d(TAG, "click start button");
            
                Intent intent = new Intent("com.test.MY_AIDL_SERVICE");
                boolean result = bindService(intent, mConnection, Context.BIND_AUTO_CREATE);
                if (!result) {
                    mBinder = null;
                }
            }
        });


        mHalf = (Button) findViewById(R.id.btHalf);
        mHalf.setOnClickListener(new View.OnClickListener() {
            
            @Override
            public void onClick(View arg0) {
                Log.d(TAG, "click half button");

                try {
                    if (mBinder != null) {
                        mBinder.halfValue(10);
                    }
                } catch (RemoteException e) {
                    e.printStackTrace();
                }
            }
        });


        mDouble = (Button) findViewById(R.id.btDouble);
        mDouble.setOnClickListener(new View.OnClickListener() {
            
            @Override
            public void onClick(View arg0) {
                Log.d(TAG, "click double button");
                
                try {
                    if (mBinder != null) {
                        mBinder.doubleValue(10);
                    }
                } catch (RemoteException e) {
                    e.printStackTrace();
                }
            }
        });
        

        mEnd = (Button) findViewById(R.id.btEnd);
        mEnd.setOnClickListener(new View.OnClickListener() {
            
            @Override
            public void onClick(View arg0) {
                Log.d(TAG, "click end button");
                
                if (mBinder != null) {
                    unbindService(mConnection);
                    mBinder = null;
                }
            }
        });
    }
    
}
